/*-----------------------------------------------------------------------

File  : can_treeanalyze.h

Author: Stephan Schulz

Contents
 
  Functions for analysing and marking dependency trees for clauses.

  Copyright 1998, 1999 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING in the main CLIB directory for details.
  Run "eprover -h" for contact information.

Changes

<1> Tue Mar 23 02:07:15 MET 1999
    New

-----------------------------------------------------------------------*/

#ifndef CAN_TREEANALYZE

#define CAN_TREEANALYZE

#include <can_infstate.h>


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/




/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

#define PROOF_DIST_INFINITY LONG_MAX /* It's magic */
#define PROOF_DIST_DEFAULT  10 /* Default for non-proofs */

long ProofMarkProofClauses(InfState_p proof);
void ProofSetClauseStatistics(InfState_p proof, long s_used, long
			      s_unused, long g_used, long g_unused,
			      long proof_distance);
void ProofComputeParentNumbers(InfState_p proof);

void ProofComputeDistance(InfState_p state);

long ProofDistanceDistrib(InfState_p state, ClauseProperties filter,
			  PDArray_p distrib);

long InfStateSelectExamples(InfState_p state, double neg_proportion,
			    long neg_examples);


#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





