/*-----------------------------------------------------------------------

File  : che_auto_cases.c

Author: Stephan Schulz

Contents
 
  Case distinction for auto mode, included by both auto heuristic
  selection and auto ordering selection

  Copyright 1998, 1999 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING in the main CLIB directory for details.
  Run "eprover -h" for contact information.

Changes

<1> Tue May  2 22:07:17 GMT 2000
    Extracted from che_heuristics.c

-----------------------------------------------------------------------*/


if(SpecAxiomsAreUnit(spec))
{
   OUTPRINT(1, "# Axioms are unit-clauses.\n");
   SpecFeaturesAddEval(spec,2,5,true, AX_SOME_DEFAULT,
		       AX_MANY_DEFAULT, LIT_SOME_DEFAULT,
		       LIT_MANY_DEFAULT, TERM_MED_DEFAULT,
		       TERM_LARGE_DEFAULT); /* Finalized */
   if(OutputLevel)
   {
      fprintf(GlobalOut, "# Problem is type ");
      SpecTypePrint(GlobalOut, spec, "aaaaaaaaa");
      fputc('\n', GlobalOut);
   }
   if(false)
   {
      assert(false);
   }
#include "che_U_____auto.c"         
}
else if(SpecAxiomsAreHorn(spec))
{
   OUTPRINT(1, "# Axioms are Horn-clauses.\n");
   SpecFeaturesAddEval(spec, 1,3,true, AX_SOME_DEFAULT,
		       AX_MANY_DEFAULT, LIT_SOME_DEFAULT,
		       LIT_MANY_DEFAULT, TERM_MED_DEFAULT,
		       TERM_LARGE_DEFAULT);
   if(OutputLevel)
   {
      fprintf(GlobalOut, "# Problem is type ");
      SpecTypePrint(GlobalOut, spec, "aaaaaaaaa");
      fputc('\n', GlobalOut);
   }
   if(false)
   {
	 assert(false);
   }
#include "che_H_____auto.c" 
}
else
{
   OUTPRINT(1, "# Axioms are general clauses.\n");      
   SpecFeaturesAddEval(spec, FEW_DEFAULT, MANY_DEFAULT, false,
		       AX_SOME_DEFAULT, AX_MANY_DEFAULT,
		       LIT_SOME_DEFAULT, LIT_MANY_DEFAULT,
		       TERM_MED_DEFAULT, TERM_LARGE_DEFAULT);
   
   if(OutputLevel)
   {
      fprintf(GlobalOut, "# Problem is type ");
      SpecTypePrint(GlobalOut, spec, "aaaaaaaaa");
      fputc('\n', GlobalOut);
   }
   if(false)
   {
      assert(false);
   }
#include "che_G_____auto.c" 
}

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/

